<?

class ParamHelper
{
 var $m_params;
 var $m_paramsAdded = array();
 var $m_paramsChanged = array();
 var $m_paramsRemoved = array();
 var $m_id = -1;
 
 function ParamHelper( $id=-1 )
 {
 if ( !is_numeric($id) ) $id = -1;
 if ( $id != -1 )
 $this->m_params = $this->load( $id );
 else
 $this->m_params = array();
 }
 
 
 function getID() {
 return $this->m_id;
 }
 
 function store() {
 if ( $this->m_id == -1 ) {
 
 $sql = "SELECT max(paramid)+1 as mid FROM param";
 $rs = query( $sql );
 $this->m_id = $rs["arr"][0]["mid"];
 if ( !$this->m_id ) $this->m_id = 1;
 
 }
 if ( count($this->m_paramsRemoved) > 0 ) {
 $tmp = "'".implode( "','", sqlf_escaped_array(array_keys($this->m_paramsRemoved)) )."'";
 $sql = "DELETE FROM param WHERE paramid=".sqlf_tl_num($this->m_id)." AND name IN ($tmp)";
 query( $sql );
 }
 foreach ( $this->m_paramsAdded as $name=>$value ) {
 $sql = "INSERT INTO param (paramid, name, value) VALUES (".sqlf_tl_num($this->m_id).", '".sqlf_escaped($name)."', '".sqlslashes($this->m_params[$name])."')";
 query( $sql );
 }
 foreach ( $this->m_paramsChanged as $name=>$value ) {
 $sql = "UPDATE param SET value = '".sqlslashes($this->m_params[$name])."' ".
 "WHERE paramid=".sqlf_tl_num($this->m_id)." AND name='".sqlf_escaped($name)."'";
 query( $sql );
 }
 }
 
 function load( $id )
 {
 $this->m_id = $id;
 $sql = "SELECT * FROM param WHERE paramid = ".sqlf_tl_num($id);
 $rs = query( $sql );
 $ret = array();
 foreach ( $rs["arr"] as $row )
 {
 $ret[$row["name"]] = $row["value"];
 }
 return $ret;
 }
 
 function getParam( $name, $default="" )
 {
 if ( !isset( $this->m_params[$name] ) ) return $default;
 return $this->m_params[$name];
 }
 
 function setParam( $name, $value )
 {
 unset( $this->m_paramsRemoved[$name] );
 if ( !isset( $this->m_params[$name] ) )
 $this->m_paramsAdded[$name] = true;
 else if ( $this->m_params[$name] != $value )
 $this->m_paramsChanged[$name] = true;
 $this->m_params[$name] = $value;
 }
 
 function unsetParam( $name )
 {
 $this->m_paramsRemoved[$name] = true;
 }
}

?>
