<?
class SelectorTreeNodeFormatter extends TreeNodeFormatter {
 var $fieldname;
 var $baselink;
 var $selector;

 function SelectorTreeNodeFormatter($fieldname, $baselink, &$selector) {
 $this->fieldname = $fieldname;
 $this->baselink = $baselink;
 $this->selector =& $selector;
 }

 function getSerializeKey() {
 return array(
 );
 }

 function initFromSerializeKey( $key ) {
 }


 function formatTreeNode($link, $node, $itype, $ntype, $nid, $atposidx) {
 
 if ($itype["object"]) {
 switch($ntype) {
 case T_PAGELANGUAGE:
 $id = $ntype;
 break;
 case T_FOLDER_CHANNEL:
 
 $fids = explode("-", substr($atposidx, 3));
 if (count($fids) > 0) {
 $rootFolderId = $fids[0];
 $finfo = get_folderinfo($rootFolderId);
 $id = "$ntype.$nid.".$finfo["node_id"];
 }
 break;
 default:
 $id = "$ntype.$nid";
 }
 } else {
 $id = $ntype;
 }

 $icon = $this->selector->renderSelection( $id );
 $action = $this->selector->getSelectionAction( $id );
 $link = '<div style="margin-left:18px;">'.$link.'</div>';
 if ($action) {
 return "<a class='gtxSelectorTreeFormatterCheckbox' href=\"".$this->baselink."&amp;".$this->fieldname."=$id\">$icon</a> $link";
 } else {
 return "<span class='gtxSelectorTreeFormatterCheckbox'>$icon</span> $link";
 }
 }

 function callAction($action, $value, $tposidx) {
 $this->selector->doSelectionAction( $action, $value );
 }
}

?>
