<?

function calc_img($text, $w, $h, $font, $fontsize, $upperyoffset = 2, $loweryoffset = 5) {

 $origh = $h;
 $fontxfactor = 6.5;
 
 $fontyfactor = .6;
 $xoffset = 5;
 $textlength = $fontxfactor*strlen($text);
 $textheight = $fontyfactor*$fontsize;

 $tb = imagettfbbox($fontsize, 0, $font, $text);
 list($pos_blx, $pos_bly, $pos_brx, $pos_bry, $pos_trx, $pos_try, $pos_tlx, $pos_tly) = $tb; 

 $_w = abs($pos_brx) + 2 * $xoffset;
 $_h = abs($pos_try) + $upperyoffset + $loweryoffset;

 if (!$w || $w < $_w) $w = $_w;
 if (!$h || $h < $_h) $h = $_h;

 
 $boxwidth = $pos_brx - $pos_blx;
 $ctx = round(($w - ($boxwidth)) / 2);

 $boxheight = $pos_bry - $pos_try;

 
 $yshift = $upperyoffset - $loweryoffset;

 
 
 $cty = round(($origh - $boxheight) / 2) + $yshift + $boxheight;
 
 $ret = array("w" => $w, "h" => $h, "tx" => $xoffset, "ty" => ($h - $loweryoffset), "ctx" => $ctx, "cty" => $cty);

 return $ret;
}

?>
